diff --git a/modules/features/chatbot/mainChatbot.py b/modules/features/chatbot/mainChatbot.py
index 1428ef41..acb9a0e6 100644
--- a/modules/features/chatbot/mainChatbot.py
+++ b/modules/features/chatbot/mainChatbot.py
@@ -666,58 +386,118 @@ Return ONLY valid JSON:
         # Extract analysis results
         needsDatabaseQuery = analysis.get("needsDatabaseQuery", False) if analysis else False
         needsWebResearch = analysis.get("needsWebResearch", False) if analysis else False
-        needsExcelFile = analysis.get("needsExcelFile", False) if analysis else False
-        excelAction = analysis.get("excelAction")
-        excelFileName = analysis.get("excelFileName")
-        sql_query = analysis.get("sqlQuery", "")
-        requested_columns = analysis.get("requestedColumns", [])
+        sql_queries = analysis.get("sqlQueries", [])
+        # Support legacy single query format for backward compatibility
+        if not sql_queries and analysis.get("sqlQuery"):
+            sql_queries = [{
+                "query": analysis.get("sqlQuery", ""),
+                "purpose": "Database query",
+                "table": "Unknown"
+            }]
+        reasoning = analysis.get("reasoning", "")
         
-        # Ensure database query if Excel update is needed
-        if needsExcelFile and excelAction == "update" and not needsDatabaseQuery:
-            needsDatabaseQuery = True
+        logger.info(f"Analysis: DB={needsDatabaseQuery}, Web={needsWebResearch}, SQL queries={len(sql_queries)}")
         
-        logger.info(f"Analysis: DB={needsDatabaseQuery}, Excel={needsExcelFile}, SQL={'present' if sql_query else 'missing'}")
+        # Build list of queries to stream back
+        queries = []
         
-        if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
+        if needsDatabaseQuery and sql_queries:
+            for i, sql_query_info in enumerate(sql_queries, 1):
+                queries.append({
+                    "type": "database",
+                    "query": sql_query_info.get("query", ""),
+                    "purpose": sql_query_info.get("purpose", f"Query {i}"),
+                    "table": sql_query_info.get("table", "Unknown"),
+                    "reasoning": reasoning
+                })
+        
+        if needsWebResearch:
+            queries.append({
+                "type": "web",
+                "query": userInput.prompt,
+                "reasoning": reasoning
+            })
+        
+        # Format queries as log text
+        log_lines = []
+        if queries:
+            db_queries = [q for q in queries if q["type"] == "database"]
+            log_lines.append(f"Generiert: {len(db_queries)} Datenbankabfrage(n) und {len(queries) - len(db_queries)} Web-Recherche(n)\n\n")
+            for i, q in enumerate(queries, 1):
+                if q["type"] == "database":
+                    log_lines.append(f"{i}. Datenbankabfrage ({q.get('table', 'Unknown')}):\n")
+                    log_lines.append(f"   Zweck: {q.get('purpose', 'Nicht angegeben')}\n")
+                    log_lines.append(f"```sql\n{q['query']}\n```\n")
+                elif q["type"] == "web":
+                    log_lines.append(f"{i}. Web-Recherche:\n")
+                    log_lines.append(f"   Suchbegriff: {q['query']}\n")
+                if q.get("reasoning"):
+                    log_lines.append(f"   Begründung: {q['reasoning']}\n")
+                log_lines.append("\n")
+        else:
+            log_lines.append("Keine Abfragen erforderlich.")
+        
+        log_text = "".join(log_lines)
+        
+        # Stream queries as a log
+        await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, log_text)
+        
+        # Check if workflow was stopped before executing queries
+        if await _check_workflow_stopped(interfaceDbChat, workflowId):
+            logger.info(f"Workflow {workflowId} was stopped, aborting query execution")
             return
         
-        # Step 2: Execute SQL Query
+        # Step 2: Execute queries
         queryResults = {}
-        queryData = {}
-        excel_documents = []
+        webResearchResults = ""
         
-        if needsDatabaseQuery and sql_query:
-            logger.info("Step 2: Executing SQL query...")
-            await event_manager.emit_event(workflowId, "status", "Führe Datenbankabfrage aus...", "query_execution")
+        # Execute database queries in parallel
+        if needsDatabaseQuery and sql_queries:
+            logger.info(f"Executing {len(sql_queries)} database queries in parallel...")
+            await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, f"Führe {len(sql_queries)} Datenbankabfrage(n) parallel aus...")
             
             try:
-                connector = PreprocessorConnector()
-                result_dict = await connector.executeQuery(sql_query, return_json=True)
-                await connector.close()
+                queryResults = await _execute_queries_parallel(sql_queries)
                 
-                if result_dict and not result_dict.get("text", "").startswith(("Error:", "Query failed:")):
-                    queryResults["main"] = result_dict.get("text", "")
-                    queryData["main"] = result_dict.get("data", [])
-                    logger.info(f"Query executed successfully, returned {len(queryData.get('main', []))} rows")
-                else:
-                    error_text = result_dict.get("text", "Query failed") if result_dict else "Query failed: No response"
-                    queryResults["error"] = error_text
-                    logger.error(f"Query failed: {error_text}")
-                    
-                    # If query failed and we need Excel update, try to extract article numbers from Excel and retry
-                    if needsExcelFile and excelAction == "update" and has_uploaded_files and "ExcelFile" in error_text:
-                        logger.warning("Query failed due to ExcelFile table reference. Attempting to extract article numbers from Excel file and retry...")
-                        # The AI should have extracted article numbers, but if query failed, we can't proceed
-                        # Log the issue for debugging
-                        logger.error("Cannot proceed with Excel update: SQL query references non-existent ExcelFile table. AI should extract article numbers directly.")
+                # Log results summary
+                successful_queries = [k for k in queryResults.keys() if k.startswith("query_") and not k.endswith("_error") and not k.endswith("_data")]
+                failed_queries = [k for k in queryResults.keys() if k.endswith("_error")]
+                
+                if successful_queries:
+                    total_rows = sum(len(queryResults.get(f"{k}_data", [])) for k in successful_queries)
+                    logger.info(f"Successfully executed {len(successful_queries)} query/queries, total {total_rows} rows")
+                    await _emit_log_and_event(
+                        interfaceDbChat, 
+                        workflowId, 
+                        event_manager, 
+                        f"Abgeschlossen: {len(successful_queries)} Abfrage(n) erfolgreich, {total_rows} Ergebnis{'e' if total_rows != 1 else ''} gefunden"
+                    )
+                
+                if failed_queries:
+                    logger.warning(f"{len(failed_queries)} query/queries failed")
+                    await _emit_log_and_event(
+                        interfaceDbChat, 
+                        workflowId, 
+                        event_manager, 
+                        f"Warnung: {len(failed_queries)} Abfrage(n) fehlgeschlagen",
+                        log_type="warning"
+                    )
             except Exception as e:
-                logger.error(f"Error executing query: {e}")
-                queryResults["error"] = f"Error executing query: {str(e)}"
+                logger.error(f"Error executing parallel queries: {e}")
+                queryResults["error"] = f"Error executing queries: {str(e)}"
+                await _emit_log_and_event(
+                    interfaceDbChat,
+                    workflowId,
+                    event_manager,
+                    "Fehler bei parallelen Datenbankabfragen",
+                    log_type="error"
+                )
         
-        # Step 2.5: Web Research (simplified)
-        webResearchResults = ""
+        # Execute web research
         if needsWebResearch:
             logger.info("Performing web research...")
+            await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Suche im Internet nach Informationen...")
+            
             try:
                 researchResult = await services.web.performWebResearch(
                     prompt=userInput.prompt,
@@ -728,221 +508,133 @@ Return ONLY valid JSON:
                     operationId=None
                 )
                 webResearchResults = json.dumps(researchResult, ensure_ascii=False, indent=2) if isinstance(researchResult, dict) else str(researchResult)
+                await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Internet-Recherche abgeschlossen")
             except Exception as e:
                 logger.error(f"Web research failed: {e}")
                 webResearchResults = f"Web research error: {str(e)}"
+                await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Internet-Recherche fehlgeschlagen", log_type="warning")
         
-        if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
+        # Check if workflow was stopped before generating final answer
+        if await _check_workflow_stopped(interfaceDbChat, workflowId):
+            logger.info(f"Workflow {workflowId} was stopped, aborting final answer generation")
             return
         
-        # Build answer context
+        # Step 3: Generate final answer using AI
+        logger.info("Generating final answer with AI...")
+        await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Formuliere finale Antwort...")
+        
+        # Build prompt for final answer
+        system_prompt = get_final_answer_system_prompt()
+        
+        # Build answer context with query results
         answerContext = f"User question: {userInput.prompt}{context}\n\n"
+        
+        # Add database results - organize by query with metadata
+        db_results_part = ""
         if queryResults:
-            for key, result in queryResults.items():
-                if key != "error":
-                    answerContext += f"Database results:\n{result}\n\n"
-        if webResearchResults:
-            answerContext += f"Web research:\n{webResearchResults}\n\n"
-        
-        # Step 3: Process Excel File
-        excel_error = None
-        if needsExcelFile:
-            logger.info(f"Step 3: Processing Excel file (action: {excelAction})...")
-            await event_manager.emit_event(
-                workflowId,
-                "status",
-                f"Erstelle Excel-Datei..." if excelAction == "create" else "Aktualisiere Excel-Datei...",
-                "excel_processing"
-            )
+            successful_results = []
+            error_results = []
             
-            try:
-                # Check if we have query data for updates
-                if excelAction == "update":
-                    if not queryData or "main" not in queryData or not queryData["main"]:
-                        error_msg = f"No query data available for Excel update. queryData keys: {list(queryData.keys()) if queryData else 'None'}"
-                        if queryResults.get("error"):
-                            error_msg += f" Query error: {queryResults['error']}"
-                        logger.error(error_msg)
-                        excel_error = f"Die Datenbankabfrage ist fehlgeschlagen: {queryResults.get('error', 'Unbekannter Fehler')}. Die Excel-Datei konnte nicht aktualisiert werden."
-                        raise ValueError(excel_error)
+            # Extract query metadata from sql_queries if available
+            query_metadata = {}
+            if sql_queries:
+                for i, q_info in enumerate(sql_queries, 1):
+                    query_metadata[f"query_{i}"] = {
+                        "purpose": q_info.get("purpose", f"Query {i}"),
+                        "table": q_info.get("table", "Unknown")
+                    }
+            
+            # Organize results by query number
+            query_numbers = set()
+            for key in queryResults.keys():
+                if key.startswith("query_") and not key.endswith("_data"):
+                    # Extract query number (e.g., "query_1" -> 1)
+                    try:
+                        num = int(key.split("_")[1])
+                        query_numbers.add(num)
+                    except (ValueError, IndexError):
+                        pass
+            
+            # Build results with metadata
+            for query_num in sorted(query_numbers):
+                query_key = f"query_{query_num}"
+                error_key = f"{query_key}_error"
                 
-                workflow = interfaceDbChat.getWorkflow(workflowId)
-                if workflow:
-                    services.workflow = workflow
-                
-                method_ai = MethodAi(services)
-                
-                # Prepare document references for updates
-                if excelAction == "update" and userInput.listFileId:
-                    if not document_references or not document_references.references:
-                        document_references = await _convert_file_ids_to_document_references(services, userInput.listFileId)
-                else:
-                    from modules.datamodels.datamodelDocref import DocumentReferenceList
-                    document_references = DocumentReferenceList(references=[])
-                
-                # Build Excel prompt
-                if excelAction == "update":
-                    # Format query data as JSON lookup table
-                    lookup_table_json = _format_query_results_as_lookup(queryData)
-                    lookup_table_dict = json.loads(lookup_table_json)
-                    logger.info(f"Generated lookup table with {len(lookup_table_dict)} entries")
-                    
-                    # Log sample entries for debugging
-                    if lookup_table_dict:
-                        sample_keys = list(lookup_table_dict.keys())[:3]
-                        logger.info(f"Sample Artikelnummern in lookup table: {sample_keys}")
-                        if sample_keys:
-                            sample_entry = lookup_table_dict[sample_keys[0]]
-                            logger.info(f"Sample entry for '{sample_keys[0]}': {list(sample_entry.keys())}")
-                            logger.info(f"Sample entry values: {sample_entry}")
-                    
-                    # Determine columns to add
-                    column_names = requested_columns if requested_columns else []
-                    if not column_names:
-                        prompt_lower = userInput.prompt.lower()
-                        if "einkaufspreis" in prompt_lower or "purchase price" in prompt_lower or "kaufpreis" in prompt_lower:
-                            column_names = ["Einkaufspreis"]
-                        elif "lieferant" in prompt_lower or "supplier" in prompt_lower:
-                            column_names = ["Lieferant"]
-                        elif "lagerbestand" in prompt_lower or "stock" in prompt_lower:
-                            column_names = ["Lagerbestand"]
-                        else:
-                            # Default: try to infer from available columns in lookup table
-                            if lookup_table_dict:
-                                sample_entry = next(iter(lookup_table_dict.values()))
-                                available_columns = list(sample_entry.keys())
-                                logger.info(f"Available columns in lookup table: {available_columns}")
-                                # Prefer common columns
-                                if "Einkaufspreis" in available_columns:
-                                    column_names = ["Einkaufspreis"]
-                                elif "Lieferant" in available_columns:
-                                    column_names = ["Lieferant"]
-                                else:
-                                    column_names = available_columns[:1] if available_columns else ["Lieferant"]
-                            else:
-                                column_names = ["Lieferant"]
-                    
-                    logger.info(f"Adding columns to Excel: {column_names}")
-                    column_name_str = ", ".join(column_names)
-                    
-                    # Build a more explicit prompt with clear instructions and the lookup table
-                    # Include the lookup table data directly in the prompt so it's always available
-                    excel_prompt = f"""You are updating an Excel file. CRITICAL TASK:
-
-Add new column(s) "{column_name_str}" to the attached Excel file by matching Artikelnummer values.
-
-STEP-BY-STEP PROCESS (MUST FOLLOW EXACTLY):
-1. Read the attached Excel file completely - all sheets, all rows, all columns.
-2. Find the column containing "Artikelnummer" (may be named "Artikelnummer", "Artikel Nummer", "Art-Nr", "Artikelnummer", etc.)
-3. For EACH ROW in the Excel file:
-   a. Read the Artikelnummer value from that row (e.g., "LED001", "12345", etc.)
-   b. Look up that EXACT Artikelnummer in the DATABASE LOOKUP TABLE below (case-sensitive match)
-   c. If the Artikelnummer is found in the lookup table:
-      - Extract the value(s) for column(s) "{column_name_str}" from the matching entry
-      - Write the value(s) to the new column(s) in that row
-   d. If the Artikelnummer is NOT found in the lookup table:
-      - Leave the new column(s) empty for that row
-4. Preserve ALL existing data, formatting, formulas, and structure exactly as-is.
-5. Return ONLY the complete modified Excel file (.xlsx format). Do NOT include any text or explanations.
-
-=== DATABASE LOOKUP TABLE (JSON) ===
-Use this table to match Artikelnummer and extract values. Format: {{"Artikelnummer": {{"column": "value", ...}}}}
-
-{lookup_table_json}
-
-=== EXAMPLE MATCHING ===
-- Excel row has Artikelnummer "LED001" in column "Artikelnummer"
-- Search for "LED001" in the lookup table above
-- Find entry: {{"LED001": {{"Lieferant": "Phoenix Contact", "Einkaufspreis": 12.50, ...}}}}
-- Extract "{column_name_str}" value from that entry
-- Write the extracted value to the new "{column_name_str}" column in that Excel row
-
-CRITICAL REQUIREMENTS:
-- Match EXACTLY by Artikelnummer (case-sensitive, exact string match)
-- Preserve ALL existing columns, rows, formatting, and formulas
-- Only add the new column(s), do NOT modify existing data
-- Return ONLY the Excel file binary data, no explanations"""
-                else:
-                    excel_prompt = f"""Create Excel file (.xlsx) from database results:
-
-{answerContext if queryResults else "No database results available."}
-
-User request: {userInput.prompt}
-
-Create well-structured spreadsheet with appropriate headers and formatting."""
-                
-                # Use simpleMode=True for Excel updates to ensure lookup table is directly accessible
-                # simpleMode=False goes through complex document generation pipeline which may lose context
-                excel_result = await method_ai.process({
-                    "aiPrompt": excel_prompt,
-                    "documentList": document_references if excelAction == "update" else None,
-                    "resultType": "xlsx",
-                    "simpleMode": True  # Use simple mode for direct Excel updates with lookup table
-                })
-                
-                if excel_result.success and excel_result.documents:
-                    for action_doc in excel_result.documents:
-                        try:
-                            chat_doc = await _create_chat_document_from_action_document(
-                                services, action_doc, "", workflowId, workflow.currentRound
-                            )
-                            if chat_doc:
-                                excel_documents.append(chat_doc)
-                        except Exception as e:
-                            logger.error(f"Error creating ChatDocument: {e}", exc_info=True)
-                    logger.info(f"Excel processing complete: {len(excel_documents)} documents")
-                else:
-                    excel_error = f"Excel-Verarbeitung fehlgeschlagen: {excel_result.error if excel_result else 'Unbekannter Fehler'}"
-                    logger.warning(excel_error)
-            except Exception as e:
-                excel_error = str(e) if not excel_error else excel_error
-                logger.error(f"Error processing Excel: {e}", exc_info=True)
+                if error_key in queryResults:
+                    error_msg = queryResults[error_key]
+                    metadata = query_metadata.get(query_key, {})
+                    purpose = metadata.get("purpose", f"Query {query_num}")
+                    table = metadata.get("table", "Unknown")
+                    error_results.append(f"Abfrage {query_num} ({table} - {purpose}): {error_msg}")
+                elif query_key in queryResults:
+                    result_text = queryResults[query_key]
+                    metadata = query_metadata.get(query_key, {})
+                    purpose = metadata.get("purpose", f"Query {query_num}")
+                    table = metadata.get("table", "Unknown")
+                    successful_results.append(f"=== Abfrage {query_num}: {purpose} (Tabelle: {table}) ===\n{result_text}")
+            
+            # Handle general error if present
+            if "error" in queryResults:
+                error_results.append(f"Allgemeiner Fehler: {queryResults['error']}")
+            
+            if successful_results:
+                db_results_part = "\n\nDATENBANK-ERGEBNISSE:\n" + "\n\n".join(successful_results)
+                answerContext += "DATENBANK-ERGEBNISSE:\n" + "\n\n".join(successful_results) + "\n\n"
+            
+            if error_results:
+                db_results_part += "\n\nDATENBANK-FEHLER:\n" + "\n".join(error_results)
+                answerContext += "DATENBANK-FEHLER:\n" + "\n".join(error_results) + "\n\n"
         
-        if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
-            return
+        # Add web research results
+        web_results_part = ""
+        if webResearchResults:
+            web_results_part = f"\n\nINTERNET-RECHERCHE:\n{webResearchResults}"
+            answerContext += f"INTERNET-RECHERCHE:\n{webResearchResults}\n\n"
         
-        # Step 4: Generate Final Answer
-        logger.info("Step 4: Generating final answer...")
-        await event_manager.emit_event(workflowId, "status", "Formuliere finale Antwort...", "answer_generation")
+        # Check if we have any actual data
+        successful_query_keys = [k for k in queryResults.keys() if k.startswith("query_") and not k.endswith("_error") and not k.endswith("_data")]
+        has_query_results = bool(successful_query_keys)
+        error_query_keys = [k for k in queryResults.keys() if k.endswith("_error")]
+        has_only_errors = bool(error_query_keys and not successful_query_keys)
         
-        excel_context = ""
-        if needsExcelFile:
-            if excel_documents:
-                file_names = [doc.fileName for doc in excel_documents]
-                action_text = "erstellt" if excelAction == "create" else "aktualisiert"
-                file_name_str = file_names[0] if len(file_names) == 1 else f"{len(file_names)} Dateien"
-                excel_context = f"\n\nWICHTIG - EXCEL-DATEI {action_text.upper()}:\nDie Excel-Datei '{file_name_str}' wurde erfolgreich {action_text} und ist als Anhang verfügbar. Erwähne dies am Ende deiner Antwort."
-            elif excel_error:
-                excel_context = f"\n\nFEHLER - EXCEL-VERARBEITUNG:\n{excel_error}\nErkläre dem Nutzer, warum die Excel-Datei nicht aktualisiert werden konnte."
+        if not has_query_results and needsDatabaseQuery:
+            db_results_part = "\n\nWICHTIG: Es wurden KEINE Datenbank-Ergebnisse gefunden. Die Datenbankabfrage wurde nicht ausgeführt oder hat keine Ergebnisse zurückgegeben."
         
-        # Build answer context parts (avoid backslashes in f-string expressions)
-        db_results_part = f"\nDATENBANK-ERGEBNISSE:\n{answerContext}" if queryResults and not queryResults.get("error") else ""
-        if queryResults.get("error"):
-            db_results_part = f"\nDATENBANK-FEHLER:\n{queryResults['error']}"
-        web_results_part = f"\nINTERNET-RECHERCHE:\n{webResearchResults}" if webResearchResults else ""
+        if has_only_errors:
+            db_results_part += "\n\n⚠️⚠️⚠️ KRITISCH - ALLE QUERIES FEHLGESCHLAGEN ⚠️⚠️⚠️\n" + \
+                              "ALLE Datenbankabfragen sind fehlgeschlagen. Es gibt KEINE gültigen Daten aus der Datenbank.\n" + \
+                              "DU DARFST KEINE DATEN ERFINDEN! Schreibe stattdessen: 'Es wurden keine Artikel gefunden' oder 'Die Datenbankabfrage ist fehlgeschlagen'."
         
-        answerPrompt = f"""Heute ist der {current_date}.
+        answer_prompt = f"""{system_prompt}
 
-Du bist ein Chatbot der Althaus AG. Antworte auf Deutsch (kein ß, immer ss).
+Antworte auf die folgende Frage des Nutzers: {userInput.prompt}{context}
 
-Antworte auf: {userInput.prompt}{context}
-{db_results_part}{web_results_part}{excel_context}
+{db_results_part}{web_results_part}
+
+KRITISCH: Verwende NUR die oben angegebenen Daten. Erfinde KEINE Werte. Wenn Daten fehlen, schreibe "Nicht verfügbar".
+
+WICHTIG - MEHRERE ABFRAGEN:
+Die oben angegebenen DATENBANK-ERGEBNISSE können aus mehreren separaten Abfragen stammen. Jede Abfrage ist mit "=== Abfrage X ===" markiert und enthält Informationen zu einem spezifischen Aspekt (z.B. Artikel-Informationen, Lagerbestände, etc.).
+- Kombiniere die Informationen aus ALLEN erfolgreichen Abfragen zu einer umfassenden Antwort
+- Beispiel: Wenn Abfrage 1 Artikel-Informationen liefert und Abfrage 2 Lagerbestände liefert, kombiniere beide in deiner Antwort
+- Verwende ALLE verfügbaren Informationen aus den verschiedenen Abfragen
+
+⚠️⚠️⚠️ ABSOLUT VERBOTEN - KEINE DATEN ERFINDEN ⚠️⚠️⚠️
+Wenn KEINE Datenbank-Ergebnisse vorhanden sind, dann:
+- ❌ ERFINDE KEINE Artikelnummern, Artikelbezeichnungen, Preise oder Lagerbestände!
+- ❌ ERFINDE KEINE Beispielartikel!
+- ✓ Schreibe stattdessen: "Es wurden keine Artikel in der Datenbank gefunden." oder "Die Datenbankabfrage ist fehlgeschlagen."
+
+WICHTIG: Deine Antwort soll NUR die finale Antwort enthalten - KEINE Planungsschritte, KEINE SQL-Queries, KEINE Zwischenschritte!
+Beginne DIREKT mit "Aus der Datenbank habe ich..." (wenn Daten vorhanden) oder "Es wurden keine Artikel gefunden" (wenn keine Daten vorhanden)."""
 
-WICHTIG:
-- Klare, strukturierte Antwort
-- Zahlen mit Tausender-Trennzeichen (7'411)
-- Markdown-Tabellen für Daten (max 20 Zeilen)
-- Artikelnummern als Link: [ARTIKELNUMMER](/details/ARTIKELNUMMER)
-- Wenn Excel-Datei erstellt wurde, bestätige dies explizit am Ende
-- Wenn Excel-Verarbeitung fehlgeschlagen ist, erkläre dem Nutzer den Fehler klar"""
-        
         answerRequest = AiCallRequest(
-            prompt=answerPrompt,
+            prompt=answer_prompt,
             context=answerContext if (queryResults or webResearchResults) else None,
             options=AiCallOptions(
                 resultFormat="txt",
                 operationType=OperationTypeEnum.DATA_ANALYSE,
-                processingMode=ProcessingModeEnum.BASIC
+                processingMode=ProcessingModeEnum.DETAILED
             )
         )
         
@@ -951,17 +643,22 @@ WICHTIG:
         
         logger.info("Final answer generated")
         
-        if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
+        # Check if workflow was stopped during AI call - if so, don't store the message
+        if await _check_workflow_stopped(interfaceDbChat, workflowId):
+            logger.info(f"Workflow {workflowId} was stopped during final answer generation, not storing message")
             return
         
-        # Step 5: Store assistant message
-        # Reload workflow to get updated message count
+        # Reload workflow to get current message count
         workflow = interfaceDbChat.getWorkflow(workflowId)
         
-        # Prepare message data with Excel documents if any
-        message_id = f"msg_{uuid.uuid4()}"
+        # Double-check workflow wasn't stopped while we were reloading
+        if workflow and workflow.status == "stopped":
+            logger.info(f"Workflow {workflowId} was stopped, not storing final message")
+            return
+        
+        # Create assistant message with final answer
         assistantMessageData = {
-            "id": message_id,
+            "id": f"msg_{uuid.uuid4()}",
             "workflowId": workflowId,
             "parentMessageId": userMessageId,
             "message": finalAnswer,
@@ -975,23 +672,8 @@ WICHTIG:
             "actionNumber": 0
         }
         
-        # Add Excel documents if any were created
-        if excel_documents:
-            # Update messageId in all Excel documents
-            for excel_doc in excel_documents:
-                excel_doc.messageId = message_id
-            
-            # Convert ChatDocuments to dict format
-            try:
-                documents_dict = [doc.model_dump() for doc in excel_documents]
-            except Exception:
-                documents_dict = [doc.dict() for doc in excel_documents]
-            
-            assistantMessageData["documents"] = documents_dict
-            assistantMessageData["documentsLabel"] = "Excel Files"
-        
         assistantMessage = interfaceDbChat.createMessage(assistantMessageData)
-        logger.info(f"Stored assistant message: {assistantMessage.id}")
+        logger.info(f"Stored assistant message with final answer: {assistantMessage.id}")
         
         # Emit message event for streaming (exact chatData format)
         message_timestamp = parseTimestamp(assistantMessage.publishedAt, default=getUtcTimestamp())
